diff -Naur -X diff_ignore rsync-3.0.6_base/lib/sysxattrs.c rsync/lib/sysxattrs.c
--- rsync-3.0.6_base/lib/sysxattrs.c	2008-03-01 15:01:41.000000000 -0500
+++ rsync/lib/sysxattrs.c	2018-09-17 15:35:28.000000000 -0400
@@ -22,6 +22,12 @@
 #include "rsync.h"
 #include "sysxattrs.h"
 
+#ifdef HAVE_OSX_XATTRS
+int xattr_options = XATTR_NOFOLLOW;
+#endif
+extern int preserve_hfs_compression;
+static time_t last_hb;
+
 #ifdef SUPPORT_XATTRS
 
 #if defined HAVE_LINUX_XATTRS
@@ -52,30 +58,100 @@
 }
 
 #elif HAVE_OSX_XATTRS
+#pragma mark Mac OS X xattrs
+
+#define XATTR_ROOTLESS_NAME "com.apple.rootless"
 
 ssize_t sys_lgetxattr(const char *path, const char *name, void *value, size_t size)
 {
-	return getxattr(path, name, value, size, 0, XATTR_NOFOLLOW);
+	ssize_t len;
+
+	if (strcmp(name, "com.apple.finder.copy.source.checksum#N") == 0) {
+		//fprintf(stderr, "DEBUG: Dropping com.apple.finder.copy.source.checksum#N xattr on %s\n", path);
+		errno = ENOATTR;
+		return -1;
+	}
+
+	if (preserve_hfs_compression > 0)
+		xattr_options |= XATTR_SHOWCOMPRESSION;
+
+	// getxattr() will allow us to fetch up to 64MB of data in one shot.
+	// Some NAS devices, however, fail to deliver more than 1MB at a time,
+	// so we'll loop and read the next chunk until we have everything.
+	// The offset is only applicable when fetching resource forks
+	if (value != NULL && strcmp(name, XATTR_RESOURCEFORK_NAME) == 0) {
+		u_int32_t offset = 0;
+		last_hb = time(NULL);
+		errno = 0;
+		while (offset < size && errno == 0) {
+			time_t now = time(NULL);
+			if (now - last_hb >= 5) {
+				last_hb = now;
+				rprintf(FINFO, "S;;;HRTBT;;;LEN;;;%.0u;;;CF;;;%s\n", offset, path);
+			}
+			errno = 0;
+			len = getxattr(path, name, value + offset, size, offset, xattr_options);
+			if (len > 0)
+				offset += len;
+		}
+		len = offset;
+	} else {
+		len = getxattr(path, name, value, size, 0, xattr_options);
+	}
+
+	return len;
 }
 
 ssize_t sys_fgetxattr(int filedes, const char *name, void *value, size_t size)
 {
-	return fgetxattr(filedes, name, value, size, 0, 0);
+	return fgetxattr(filedes, name, value, size, 0, (preserve_hfs_compression > 0) ? XATTR_SHOWCOMPRESSION : 0);
 }
 
 int sys_lsetxattr(const char *path, const char *name, const void *value, size_t size)
 {
-	return setxattr(path, name, value, size, 0, XATTR_NOFOLLOW);
+	int ret = 0;
+	
+//	if (strcmp(name, XATTR_ROOTLESS_NAME) == 0) {
+//		fprintf(stderr, "DEBUG: Dropping com.apple.rootless xattr on %s\n", path);
+//		return ret;
+//	}
+
+	// If we're transferring a resource fork that is > SETXATTR_CHUNKSIZE, chunk the data to avoid io timeouts
+	if (value != NULL && strcmp(name, XATTR_RESOURCEFORK_NAME) == 0) {
+		u_int32_t offset = 0;
+		u_int32_t nextChunk = size - offset > SETXATTR_CHUNKSIZE ? SETXATTR_CHUNKSIZE : size - offset;
+		last_hb = time(NULL);
+		while (offset < size && ret == 0) {
+			time_t now = time(NULL);
+			if (now - last_hb >= 5) {
+				last_hb = now;
+				rprintf(FINFO, "S;;;HRTBT;;;LEN;;;%.0u;;;CF;;;%s\n", offset, path);
+			}
+			errno = 0;
+			ret = setxattr(path, name, value + offset, nextChunk, offset, xattr_options);
+			offset += nextChunk;
+			nextChunk = size - offset > SETXATTR_CHUNKSIZE ? SETXATTR_CHUNKSIZE : size - offset;
+		}
+
+	} else {
+		ret = setxattr(path, name, value, size, 0, XATTR_NOFOLLOW);
+	}
+	
+	return ret;
 }
 
 int sys_lremovexattr(const char *path, const char *name)
 {
-	return removexattr(path, name, XATTR_NOFOLLOW);
+	//if (preserve_hfs_compression > 0)
+		xattr_options |= XATTR_SHOWCOMPRESSION;
+	return removexattr(path, name, xattr_options);
 }
 
 ssize_t sys_llistxattr(const char *path, char *list, size_t size)
 {
-	return listxattr(path, list, size, XATTR_NOFOLLOW);
+	if (preserve_hfs_compression > 0)
+		xattr_options |= XATTR_SHOWCOMPRESSION;
+	return listxattr(path, list, size, xattr_options);
 }
 
 #elif HAVE_FREEBSD_XATTRS
diff -Naur -X diff_ignore rsync-3.0.6_base/log.c rsync/log.c
--- rsync-3.0.6_base/log.c	2010-10-25 14:18:07.000000000 -0400
+++ rsync/log.c	2014-12-06 21:12:18.000000000 -0500
@@ -21,6 +21,7 @@
 
 #include "rsync.h"
 #include "ifuncs.h"
+#include <sys/un.h>
 
 extern int verbose;
 extern int dry_run;
@@ -118,8 +119,7 @@
 	if (logfile_was_closed)
 		logfile_reopen();
 	if (logfile_fp) {
-		fprintf(logfile_fp, "%s [%d] %s",
-			timestring(time(NULL)), (int)getpid(), buf);
+		fprintf(logfile_fp, "%s", buf);
 		fflush(logfile_fp);
 	} else {
 		syslog(priority, "%s", buf);
@@ -152,16 +152,60 @@
 
 static void logfile_open(void)
 {
+	struct stat sf;
+	struct sockaddr_un sa;
+	int sock;
+	sig_t pipeSet;
+#ifdef HAVE_SIGACTION
+	static struct sigaction sigact;
+#endif
+
 	mode_t old_umask = umask(022 | orig_umask);
-	logfile_fp = fopen(logfile_name, "a");
+
+	if (stat(logfile_name, &sf) == 0 && S_ISSOCK(sf.st_mode)) {
+		pipeSet = SIGACTION(SIGPIPE, SIG_IGN);
+		if (pipeSet == SIG_ERR) {
+			fprintf(stderr, "logfile_open: Could not ignore SIGPIPE: %d\n", errno);
+			goto syslog_failover;
+		}
+		if (strlen(logfile_name) > (sizeof(sa.sun_path) - 1)) {
+			fprintf(stderr, "logfile_open: The socket file path is too long (> %u): %s\n", (uint) sizeof(sa.sun_path) - 1, logfile_name);
+			goto syslog_failover;
+		}
+
+		if ((sock = socket(AF_UNIX, SOCK_STREAM, 0)) == -1) {
+			fprintf(stderr, "logfile_open: socket() failed: %d\n", errno);
+			goto syslog_failover;
+		}
+
+		bzero((char*) &sa, sizeof(sa));
+		sa.sun_family = AF_UNIX;
+		memmove(sa.sun_path, logfile_name, strlen(logfile_name));
+		(void) setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, NULL, 0);
+
+		if ((connect(sock, (struct sockaddr *)(&sa), sizeof(struct sockaddr_un))) == - 1) {
+			fprintf(stderr, "logfile_open: connect() failed: %d\n", errno);
+			close(sock);
+			goto syslog_failover;
+		}
+		
+		logfile_fp = fdopen(sock, "a");
+		if (!logfile_fp)
+			close(sock);
+	} else {
+		logfile_fp = fopen(logfile_name, "a");
+	}
+
 	umask(old_umask);
 	if (!logfile_fp) {
 		int fopen_errno = errno;
-		/* Rsync falls back to using syslog on failure. */
-		syslog_init();
 		rsyserr(FERROR, fopen_errno,
 			"failed to open log-file %s", logfile_name);
 		rprintf(FINFO, "Ignoring \"log file\" setting.\n");
+
+syslog_failover:
+		/* Rsync falls back to using syslog on failure. */
+		syslog_init();
 	}
 }
 
@@ -195,8 +239,9 @@
 	 * rsyncs will have already set logfile_name, as needed.) */
 	if (am_daemon && !logfile_name)
 		logfile_name = lp_log_file(module_id);
-	if (logfile_name && *logfile_name)
+	if (logfile_name && *logfile_name) {
 		logfile_open();
+	}
 	else
 		syslog_init();
 }
@@ -274,7 +319,8 @@
 
 	if (code == FCLIENT)
 		code = FINFO;
-	else if (am_daemon || logfile_name) {
+	// BOMBICH -- added " && (logfile_name && code != FINFO)" -- I don't want FINFO messages going to the log
+	else if (am_daemon || (logfile_name && code == FLOG)) {
 		static int in_block;
 		char msg[2048];
 		int priority = code == FINFO || code == FLOG ? LOG_INFO :  LOG_WARNING;
@@ -467,7 +513,7 @@
 	int64 b;
 
 	*fmt = '%';
-
+	
 	/* We expand % codes one by one in place in buf.  We don't
 	 * copy in the terminating null of the inserted strings, but
 	 * rather keep going until we reach the null of the format. */
@@ -502,8 +548,9 @@
 			break;
 		case 'l':
 			strlcat(fmt, ".0f", sizeof fmt);
+			double flength = stats.total_transferred_size - initial_stats->total_transferred_size;
 			snprintf(buf2, sizeof buf2, fmt,
-				 (double)F_LENGTH(file));
+				 flength);
 			n = buf2;
 			break;
 		case 'U':
@@ -529,9 +576,13 @@
 			n = buf2;
 			break;
 		case 'M':
-			n = c = timestring(file->modtime);
-			while ((c = strchr(c, ' ')) != NULL)
-				*c = '-';
+			strlcat(fmt, ".0lu", sizeof fmt);
+			snprintf(buf2, sizeof buf2, fmt,
+				 (unsigned long)file->modtime);
+			n = buf2;
+//			n = c = timestring(file->modtime);
+//			while ((c = strchr(c, ' ')) != NULL)
+//				*c = '-';
 			break;
 		case 'B':
 			c = buf2 + MAXPATHLEN - PERMSTRING_SIZE - 1;
@@ -658,13 +709,19 @@
 			n = buf2;
 			break;
 		case 'i':
-			if (iflags & ITEM_DELETED) {
-				n = "*deleting  ";
-				break;
-			}
+//			if (iflags & ITEM_DELETED) {
+//				n = "*deleting   ";
+//				break;
+//			}
 			n  = c = buf2 + MAXPATHLEN - 32;
 			c[0] = iflags & ITEM_LOCAL_CHANGE
 			      ? iflags & ITEM_XNAME_FOLLOWS ? 'h' : 'c'
+			     : (iflags & ITEM_HAD_ERRORS_SOURCE) ? 'E'
+			     : (iflags & ITEM_HAD_ERRORS_DEST) ? '3'
+			     : (iflags & ITEM_DELETED) ? '*'
+			     : (iflags & ITEM_EXCLUDED) ? 'X'
+			     : (iflags & ITEM_PROTECTED) ? '('
+			     : (iflags & ITEM_ARCHIVED) ? 'A'
 			     : !(iflags & ITEM_TRANSFER) ? '.'
 			     : !local_server && *op == 's' ? '<' : '>';
 			if (S_ISLNK(file->mode)) {
@@ -776,7 +833,7 @@
 {
 	const char *s_or_r = am_sender ? "send" : "recv";
 
-	if (code != FLOG && stdout_format && !am_server) {
+	if (code != FLOG && stdout_format && !am_server && verbose > 1) {
 		log_formatted(FCLIENT, stdout_format, s_or_r,
 			      file, NULL, initial_stats, iflags, hlink);
 	}
@@ -815,25 +872,63 @@
 
 	x.file.mode = mode;
 
-	if (!verbose && !stdout_format)
-		;
-	else if (am_server && protocol_version >= 29 && len < MAXPATHLEN) {
+//	if (!verbose && !stdout_format)
+//		;
+	if (am_server && protocol_version >= 29 && len < MAXPATHLEN) {
 		if (S_ISDIR(mode))
 			len++; /* directories include trailing null */
 		send_msg(MSG_DELETED, fname, len, am_generator);
-	} else {
+	} else if (verbose) {
 		fmt = stdout_format_has_o_or_i ? stdout_format : "deleting %n";
 		log_formatted(FCLIENT, fmt, "del.", &x.file, fname, &stats,
 			      ITEM_DELETED, NULL);
 	}
 
-	if (!logfile_name || dry_run || !logfile_format)
+	if (!logfile_name || !logfile_format)
 		return;
 
 	fmt = logfile_format_has_o_or_i ? logfile_format : "deleting %n";
 	log_formatted(FLOG, fmt, "del.", &x.file, fname, &stats, ITEM_DELETED, NULL);
 }
 
+void log_non_transfer(const char *fname, int mode, int iflags)
+{
+	static struct {
+		union file_extras ex[4]; /* just in case... */
+		struct file_struct file;
+	} x;
+	int len = strlen(fname);
+	const char *fmt, *prefix;
+	int msg;
+
+	x.file.mode = mode;
+	if (iflags & (ITEM_EXCLUDED | ITEM_PROTECTED)) {
+		fmt = stdout_format_has_o_or_i ? stdout_format : "filtering %n";
+		msg = MSG_FILTERED;
+		prefix = "fil.";
+	} else {
+		fmt = stdout_format_has_o_or_i ? stdout_format : "archiving %n";
+		msg = MSG_ARCHIVED;
+		prefix = "arc.";
+	}
+
+	if (am_server && protocol_version >= 29 && len < MAXPATHLEN) {
+		if (S_ISDIR(mode))
+			len++; /* directories include trailing null */
+		send_msg(msg, fname, len, am_generator);
+	} else if (verbose) {
+		log_formatted(FCLIENT, fmt, prefix, &x.file, fname, &stats,
+			      iflags, NULL);
+	}
+
+	if (!logfile_name || !logfile_format)
+		return;
+
+	fmt = logfile_format_has_o_or_i ? logfile_format : 
+				iflags & (ITEM_EXCLUDED | ITEM_PROTECTED) ? "filtering %n" : "archiving %n";
+	log_formatted(FLOG, fmt, prefix, &x.file, fname, &stats, iflags, NULL);
+}
+
 /*
  * Called when the transfer is interrupted for some reason.
  *
@@ -843,6 +938,7 @@
 void log_exit(int code, const char *file, int line)
 {
 	if (code == 0) {
+		if (verbose)
 		rprintf(FLOG,"sent %.0f bytes  received %.0f bytes  total size %.0f\n",
 			(double)stats.total_written,
 			(double)stats.total_read,
diff -Naur -X diff_ignore rsync-3.0.6_base/main.c rsync/main.c
--- rsync-3.0.6_base/main.c	2010-10-25 14:18:07.000000000 -0400
+++ rsync/main.c	2019-01-14 13:39:39.000000000 -0500
@@ -27,6 +27,31 @@
 #include <locale.h>
 #endif
 
+#include <math.h>
+#ifndef _PC_XATTR_SIZE_BITS
+#define _PC_XATTR_SIZE_BITS 26
+#endif
+
+
+// For getattrlist()
+#include <sys/attr.h>
+
+// For dirname()
+#include <libgen.h>
+
+// For chflags
+#include <sys/stat.h>
+#include <unistd.h>
+
+// For statfs():
+#include <sys/param.h>
+#include <sys/mount.h>
+
+#ifdef SUPPORT_FORCE_CHANGE
+#include <sys/types.h>
+#include <sys/sysctl.h>
+#endif
+
 extern int verbose;
 extern int dry_run;
 extern int list_only;
@@ -35,6 +60,7 @@
 extern int am_sender;
 extern int am_generator;
 extern int am_daemon;
+int rcvr_is_non_local_server = 0;
 extern int inc_recurse;
 extern int blocking_io;
 extern int always_checksum;
@@ -49,6 +75,24 @@
 extern int copy_unsafe_links;
 extern int keep_dirlinks;
 extern int preserve_hard_links;
+extern int preserve_hfs_compression;
+int fs_supports_hfs_compression = 0;
+extern uid_t sender_uid;
+extern uid_t receiver_uid;
+int write_size;
+extern float write_size_multiplier;
+extern int force_change;
+extern int preserve_fileflags;
+extern int preserve_acls;
+extern int preserve_uid;
+extern int preserve_gid;
+int disable_acl_support = 0;
+int ownershipDisabledOnDest = 0;
+int unsupported_fileflags = 0;
+int fs_supports_native_xattrs = 0;
+long pc_name_max = NAME_MAX;
+size_t pc_xattr_max_size = 4096;
+extern int preserve_links;
 extern int protocol_version;
 extern int file_total;
 extern int recurse;
@@ -89,6 +133,8 @@
 mode_t orig_umask = 0;
 int batch_gen_fd = -1;
 int sender_keeps_checksum = 0;
+const char *srcRoot;
+const char *dstRoot;
 
 /* There's probably never more than at most 2 outstanding child processes,
  * but set it higher, just in case. */
@@ -246,6 +292,9 @@
 	if (do_stats) {
 		rprintf(FCLIENT, "\n");
 		rprintf(FINFO,"Number of files: %d\n", stats.num_files);
+		rprintf(FINFO,"Number of extended attributes: %d\n", stats.num_xattrs);
+		rprintf(FINFO,"Size of transferred xattrs: %s bytes\n",
+			human_num(stats.xattr_transfer_size));
 		rprintf(FINFO,"Number of files transferred: %d\n",
 			stats.num_transferred_files);
 		rprintf(FINFO,"Total file size: %s bytes\n",
@@ -272,7 +321,7 @@
 			human_num(total_read));
 	}
 
-	if (verbose || do_stats) {
+	if (verbose > 1 || do_stats) {
 		rprintf(FCLIENT, "\n");
 		rprintf(FINFO,
 			"sent %s bytes  received %s bytes  %s bytes/sec\n",
@@ -584,7 +633,7 @@
 		 && strcmp(flist->files[flist->low]->basename, ".") == 0)
 			flist->files[0]->flags |= FLAG_DIR_CREATED;
 
-		if (verbose)
+		if (verbose > 1)
 			rprintf(FINFO, "created directory %s\n", dest_path);
 
 		if (dry_run) {
@@ -907,6 +956,7 @@
 		recv_additional_file_list(f_in);
 	verbose = save_verbose;
 
+	//fprintf(stderr, "DEBUG: [%s]do_server_recv received %d items\n", who_am_i(), flist->used);
 	if (argc > 0)
 		local_name = get_local_name(flist,argv[0]);
 
@@ -953,25 +1003,355 @@
 }
 
 
+int filesystem_capabilities(const char *path, struct statfs *fsb, u_int32_t *capability_fmt, u_int32_t *capability_int)
+{
+	char *parent;
+	int ret, saved_err;
+	
+	ret = statfs(path, fsb);
+	if (ret != 0) {
+		saved_err = errno;
+		if ((parent = dirname((char *)path)) != NULL)
+			ret = statfs(parent, fsb);
+		errno = saved_err;
+	}
+	
+	if (ret == 0) {
+		struct attrlist attrs;
+		struct {
+			int32_t len;
+			vol_capabilities_set_t caps;
+		} attrData;
+		
+		bzero(&attrs, sizeof(attrs));
+		attrs.bitmapcount = ATTR_BIT_MAP_COUNT;
+		attrs.volattr = ATTR_VOL_INFO | ATTR_VOL_CAPABILITIES;
+		
+		bzero(&attrData, sizeof(attrData));
+		attrData.len = sizeof(attrData);
+		
+		ret = getattrlist(fsb->f_mntonname, &attrs, &attrData, sizeof(attrData), 0);
+		if (ret == 0) {
+			*capability_fmt = attrData.caps[VOL_CAPABILITIES_FORMAT];
+			*capability_int = attrData.caps[VOL_CAPABILITIES_INTERFACES];
+		} else {
+			rprintf(FERROR, "Failure in getattrlist while determining filesystem capabilities on %s (%s): %s\n", path, who_am_i(), strerror(errno));
+		}
+	} else {
+		rprintf(FERROR, "Failure in statfs while determining filesystem capabilities on %s (%s): %s\n", path, who_am_i(), strerror(errno));
+	}
+	return ret;
+}
+
+void do_filesystem_compatibility_checks(const char *path)
+{
+	u_int32_t capability_fmt;
+	u_int32_t capability_int;
+	struct statfs fsb;
+
+	if (verbose > 1)
+		fprintf(stderr, "do_filesystem_compatibility_checks: filesystem_capabilities(%s)\n", path);
+	
+	if (am_sender)
+		srcRoot = path;
+	else
+		dstRoot = path;
+
+	// BOMBICH
+#ifdef ARCH_IS_64
+	fprintf(stderr, "DEBUG: [%s] Running the x86_64 executable\n", who_am_i());
+#endif
+	// Set euid as requested by caller
+	uid_t my_uid = am_sender ? sender_uid : receiver_uid;
+	uid_t savedEuid = geteuid();
+	if (savedEuid == 0 && my_uid != 0) {
+		seteuid(my_uid);
+	}
+	fprintf(stderr, "DEBUG: [dfcc: %s] Effective UID is %d for %s [Saved euid: %d]\n", who_am_i(), geteuid(), path, savedEuid);
+	//sleep(10);
+	
+// I may eventually want to add an argument to modify this behavior,
+// but for now, I want it to be the default
+#define DONT_CREATE_TARGET_ROOT 1
+#if DONT_CREATE_TARGET_ROOT
+	struct stat st;
+	st.st_mode = 0;
+	errno = 0;
+	int doStatRet = do_stat(path, &st);
+	if (doStatRet != 0 && errno == EACCES && savedEuid != my_uid) {
+		fprintf(stderr, "DEBUG: stat on %s root directory failed with EACCES. Setting effective UID back to %d and trying again\n", am_sender ? "source" : "destination", savedEuid);
+		seteuid(savedEuid);
+		st.st_mode = 0;
+		errno = 0;
+		doStatRet = do_stat(path, &st);
+		if (doStatRet == 0) {
+			fprintf(stderr, "DEBUG: stat on %s root directory succeeded with euid of %d\n", am_sender ? "source" : "destination", savedEuid);
+			if (am_sender)
+				sender_uid = savedEuid;
+			else
+				receiver_uid = savedEuid;
+		}
+	}
+
+	if (doStatRet != 0 || !S_ISDIR(st.st_mode)) {
+		rprintf(FERROR, "ERROR: %s root directory does not exist (\"%s\") (%d,%d,%o)\n", am_sender ? "source" : "destination", path, doStatRet, errno, st.st_mode);
+		exit_cleanup(RERR_FILESELECT);
+	} else {
+		fprintf(stderr, "DEBUG: %s: %d:%o\n", path, st.st_uid, st.st_mode);
+	}
+#endif
+
+	if (filesystem_capabilities(path, &fsb, &capability_fmt, &capability_int) != 0) {
+		fprintf(stderr, "DEBUG: [dfcc: %s] Setting effective UID back to %d for %s\n", who_am_i(), savedEuid, am_sender ? "source" : "dest");
+		seteuid(savedEuid);
+		return;
+	}
+
+#ifdef SUPPORT_HFS_COMPRESSION
+	fs_supports_hfs_compression = capability_fmt & VOL_CAP_FMT_DECMPFS_COMPRESSION;
+	if (verbose > 1)
+		fprintf(stderr, "do_filesystem_compatibility_checks: fs_supports_hfs_compression = %d, preserve_hfs_compression: %d\n", fs_supports_hfs_compression, preserve_hfs_compression);
+	if (preserve_hfs_compression > 0) {
+		// If the filesystem doesn't support compression and 
+		// decmpfs protection wasn't requested, disable support for compression
+		if (!fs_supports_hfs_compression && preserve_hfs_compression < 2) {
+			preserve_hfs_compression = 0;
+			unsupported_fileflags |= UF_COMPRESSED;
+			rprintf(FERROR, "DEBUG: %s: Disabling HFS compression support, %s doesn't support it (use --protect-decmpfs to force protection of the com.apple.decmpfs extended attribute).\n", who_am_i(), path);
+		}
+	}
+#endif
+
+#ifdef SUPPORT_ACLS
+	int acls_supported = capability_int & VOL_CAP_INT_EXTENDED_SECURITY;
+	if (verbose)
+		rprintf(FERROR, "DEBUG: ACLs are %s on %s\n", acls_supported ? "supported" : "not supported", path);
+	if (!am_sender && preserve_acls && !acls_supported) {
+		//preserve_acls = 0; // This creates a protocol incompatiblity because we can't communicate it to the other side
+		disable_acl_support = 1;
+		rsyserr(FERROR, ENOTSUP, "Disabling ACL support, \"%s\" doesn't support it", path);
+	}
+#endif
+
+// Determine if the filesystem supports native extended attributes (e.g. vs. stuffing them into AppleDouble files)
+// Not providing native support for extended attributes doesn't mean that support for xattrs should be disabled
+// The setxattr() implementation should automatically handle non-native xattr implementations
+// If the fs supports xattrs natively, then we will handle resource forks like regular files (writing with setxattr at offsets though).
+// If the fs does not support native xattrs, then resource forks will be treated like all other xattrs 
+// Re-enable this block when support for Tiger is dropped (Tiger doesn't report whether xattrs are supported)
+#ifdef SUPPORT_XATTRS
+	fs_supports_native_xattrs = capability_int & VOL_CAP_INT_EXTENDED_ATTR;
+	if (verbose)
+		rprintf(FERROR, "DEBUG: Extended Attributes are %s on %s\n", fs_supports_native_xattrs ? "supported" : "not supported", path);
+#endif
+
+#ifdef SUPPORT_HARD_LINKS
+	int hl_supported = capability_fmt & VOL_CAP_FMT_HARDLINKS;
+	if (verbose)
+		rprintf(FERROR, "DEBUG: Hard Links are %s on %s (%d)\n", hl_supported ? "supported" : "not supported", path, hl_supported);
+	if (preserve_hard_links && !hl_supported) {
+		preserve_hard_links = 0;
+		rsyserr(FERROR, ENOTSUP, "Disabling Hard Link support, \"%s\" doesn't support them", path);
+	}
+	
+	int cs_supported = capability_fmt & VOL_CAP_FMT_CASE_SENSITIVE;
+	rprintf(FERROR, "DEBUG: %s %s case sensitivity (%d)\n", path, cs_supported ? "supports" : "does not support", cs_supported);
+	
+#endif
+
+//#ifdef SUPPORT_LINKS
+//	int sl_supported = capability_fmt & VOL_CAP_FMT_SYMBOLICLINKS;
+//	if (verbose)
+//		rprintf(FINFO, "DEBUG: Symbolic Links are %s on %s (%d)\n", sl_supported ? "supported" : "not supported", path, sl_supported);
+//	if (preserve_hard_links && !sl_supported) {
+//		preserve_links = 0;
+//		rsyserr(FERROR, ENOTSUP, "Disabling Symbolic Link support, \"%s\" doesn't support them", path);
+//	}
+//	
+//#endif
+
+#ifdef SUPPORT_FORCE_CHANGE
+	if (force_change & SYS_IMMUTABLE) {
+		// determine whether we'll be able to unlock a system immutable item
+		int mib[2];
+		int securityLevel = 0;
+		size_t len = sizeof(securityLevel);
+
+		mib[0] = CTL_KERN;
+		mib[1] = KERN_SECURELVL;
+		if (sysctl(mib, 2, &securityLevel, &len, NULL, 0) == 0 && securityLevel > 0) {
+			//rprintf(FINFO, "System security level is too high to force mutability on system immutable files and directories.\n");
+			force_change = force_change & USR_IMMUTABLE ? USR_IMMUTABLE : 0;
+		}
+	}
+#endif
+
+#ifdef SUPPORT_FILEFLAGS
+	if (preserve_fileflags) {
+		if (dry_run != 0) {
+			fprintf(stderr, "DEBUG: [%s] Skipping fileflags test during dry run\n", who_am_i());
+		} else {
+			// Unfortunately there's no way to interrogate the
+			// filesystem directly to learn which flags are supported
+			// Instead, we'll test the available flags (except for
+			// system immutable and system appendable) to see if any flags are unsupported
+			char testfile[MAXPATHLEN];
+			int volIsLocal = fsb.f_flags & MNT_LOCAL;
+			if (snprintf(testfile, MAXPATHLEN, "%s/.fileflags_compat", path) > 0) {
+				// If the filesystem wasn't mounted as root, and I'm running as root,
+				// I need to seteuid() to the fs owner otherwise open(foo, O_CREAT) fails
+				// I also need to add SF_ARCHIVED | SF_IMMUTABLE | SF_APPEND to unsupported_fileflags because those
+				// bits are only settable by root, and I won't be root for this fs
+				if (geteuid() != 0 || !volIsLocal)
+					unsupported_fileflags |= SF_ARCHIVED | SF_IMMUTABLE | SF_APPEND | SF_RESTRICTED | SF_NOUNLINK;
+
+				if (force_change && (st.st_flags & UF_IMMUTABLE) > 0) {
+					errno = 0;
+					int ret = make_mutable(path, st.st_mode, st.st_flags, force_change);
+					if (!am_sender || errno != EROFS)
+						fprintf(stderr, "DEBUG: %s was locked. Attempt to unlock it %s [%d]\n", path, ret == 1 ? "succeeded" : ret == -1 ? "failed" : "was not required", errno);
+				}
+
+				int tfd = do_open(testfile, O_RDONLY | O_CREAT, 0666);
+				if (tfd > 0) {
+					close(tfd);
+					
+					if (chflags(testfile, 0) != 0 && errno == ENOTSUP) {
+						// Disable fileflags altogether
+						rsyserr(FERROR, ENOTSUP, "Disabling File Flags support, \"%s\" doesn't support them", path);
+						// Setting preserve_fileflags to 0 would create a protocol incompatibility, so we just mask them all off instead
+						unsupported_fileflags = ALL_FFLAGS;
+					
+					} else {
+						if (chflags(testfile, UF_NODUMP) != 0 && errno == EINVAL)
+							unsupported_fileflags |= UF_NODUMP;
+						if (chflags(testfile, UF_IMMUTABLE) != 0 && errno == EINVAL)
+							unsupported_fileflags |= UF_IMMUTABLE;
+						if (chflags(testfile, UF_APPEND) != 0 && errno == EINVAL)
+							unsupported_fileflags |= UF_APPEND;
+						if (chflags(testfile, UF_OPAQUE) != 0 && errno == EINVAL)
+							unsupported_fileflags |= UF_OPAQUE;
+						// The UF_COMPRESSED flag is handled above in the HFS compression section
+	//					if (chflags(testfile, UF_COMPRESSED) != 0 && errno == EINVAL)
+	//						unsupported_fileflags |= UF_COMPRESSED;
+						if (chflags(testfile, UF_TRACKED) != 0 && errno == EINVAL)
+							unsupported_fileflags |= UF_TRACKED;
+						if (chflags(testfile, UF_HIDDEN) != 0 && errno == EINVAL)
+							unsupported_fileflags |= UF_HIDDEN;
+
+						if (geteuid() == 0 && chflags(testfile, SF_ARCHIVED) != 0 && errno == EINVAL)
+							unsupported_fileflags |= SF_ARCHIVED;
+						// Don't test the following flags because the system security level may
+						// require single user mode to delete the test file
+						//if (chflags(testfile, SF_APPEND) != 0 && errno == EINVAL)
+						//	unsupported_fileflags |= SF_APPEND;
+						//if (chflags(testfile, SF_IMMUTABLE) != 0 && errno == EINVAL)
+						//	unsupported_fileflags |= SF_IMMUTABLE;
+						
+						chflags(testfile, 0);
+
+						fprintf(stderr, "DEBUG: [%s] Fileflags mask for %s: %d\n", who_am_i(), path, unsupported_fileflags);
+					}
+					
+					unlink(testfile);
+				} else if (errno == EROFS || errno == EACCES) {
+					fprintf(stderr, "DEBUG: [dfcc: %s] Cannot determine the level of fileflags support because the %s is read only or we don't have an adequate level of access\n", who_am_i(), am_sender ? "source" : "dest");
+				} else {
+					// Disable fileflags altogether
+					rsyserr(FERROR, ENOTSUP, "Disabling File Flags support, unable to determine support for them on \"%s\"", path);
+					// Setting preserve_fileflags to 0 would create a protocol incompatibility, so we just mask them all off instead
+					unsupported_fileflags = ALL_FFLAGS;
+				}
+				
+				if (force_change && (st.st_flags & UF_IMMUTABLE) > 0) {
+					errno = 0;
+					int ret = undo_make_mutable(path, st.st_flags);
+					if (!am_sender || errno != EROFS)
+						fprintf(stderr, "DEBUG: Re-locking %s %s. [%d]\n", path, ret > 0 ? "succeeded" : "failed", errno);
+				}
+			}
+		}
+	}
+#endif
+
+	if (!am_sender) {
+		// Determine the maximum number of bytes in a file name 
+		long _name_chars_max = pathconf(path, _PC_NAME_CHARS_MAX);
+		if (_name_chars_max == -1) {
+			fprintf(stderr, "DEBUG: Destination filesystem doesn't support _PC_NAME_CHARS_MAX, will use _PC_NAME_MAX instead\n");
+			_name_chars_max = pathconf(path, _PC_NAME_MAX);
+		}
+		
+		if (_name_chars_max != -1 && _name_chars_max < NAME_MAX)
+			pc_name_max = _name_chars_max;
+
+		if (pc_name_max < NAME_MAX)
+			fprintf(stderr, "DEBUG: Max file name length for the destination filesystem is %ld\n", pc_name_max);
+		
+		// Determine the maximum size allowed for non-resource-fork xattrs
+		long ret = pathconf(path, _PC_XATTR_SIZE_BITS);
+		if (ret > 0) {
+			if (ret == 18 || ret > 31)
+				pc_xattr_max_size = 131072; // 128KB
+			else
+				pc_xattr_max_size = exp2(ret) - 1;
+		}
+		fprintf(stderr, "DEBUG: Max xattr size for the destination filesystem is %ld bytes\n", pc_xattr_max_size);
+		
+		write_size = (int)((float)fsb.f_iosize * write_size_multiplier);
+		if (write_size <= 0)
+			write_size = 1024*1024*write_size_multiplier;
+		fprintf(stderr, "DEBUG: Setting write size to %d (%d * %.2f)\n", write_size, fsb.f_iosize, write_size_multiplier);
+	}
+
+	
+	// Now reset euid back to what it was originally.
+	// If it needs to be something else, start_client() 
+	// will set the required value.
+	fprintf(stderr, "DEBUG: [dfcc: %s] Setting effective UID back to %d for %s\n", who_am_i(), savedEuid, am_sender ? "source" : "dest");
+	seteuid(savedEuid);
+
+	
+	// Determine if we can set ownership on files
+	if (geteuid() == 0 && receiver_uid == 0 && !am_sender) {
+		ownershipDisabledOnDest = (fsb.f_flags & MNT_LOCAL) > 0 ? (fsb.f_flags & MNT_IGNORE_OWNERSHIP) > 0 : 1;
+		if (ownershipDisabledOnDest)
+			rsyserr(FERROR, ENOTSUP, "Disabling Owner and Group support, \"%s\" doesn't support those attributes", path);
+	}
+	
+}
+
 void start_server(int f_in, int f_out, int argc, char *argv[])
 {
 	set_nonblocking(f_in);
 	set_nonblocking(f_out);
 
 	io_set_sock_fds(f_in, f_out);
+	if (!local_server)
+		do_filesystem_compatibility_checks(argv[argc - 1]);
 	setup_protocol(f_out, f_in);
 
 	if (protocol_version >= 23)
 		io_start_multiplex_out();
 
+	// BOMBICH
+	uid_t my_uid = am_sender ? sender_uid : receiver_uid;
+	if (geteuid() == 0 && my_uid != 0) {
+		fprintf(stderr, "DEBUG: [start_server: %s] Setting effective UID to %d\n", who_am_i(), my_uid);
+		seteuid(my_uid);
+		am_root = geteuid() == 0;
+	}
+
 	if (am_sender) {
 		keep_dirlinks = 0; /* Must be disabled on the sender. */
 		if (need_messages_from_generator)
 			io_start_multiplex_in();
 		recv_filter_list(f_in);
 		do_server_sender(f_in, f_out, argc, argv);
-	} else
+	} else {
+		rcvr_is_non_local_server = local_server ? 0 : 1;
 		do_server_recv(f_in, f_out, argc, argv);
+	}
 	exit_cleanup(0);
 }
 
@@ -1008,6 +1388,15 @@
 	if (am_sender) {
 		keep_dirlinks = 0; /* Must be disabled on the sender. */
 
+//#ifdef ARCH_IS_64
+//	fprintf(stderr, "DEBUG: [sender] Running the x86_64 executable\n");
+//#endif
+//
+//		if (src_fs_owner != 0 && geteuid() == 0) {
+//			fprintf(stderr, "DEBUG: [sender] Setting effective UID to the filesystem owner: %d\n", src_fs_owner);
+//			seteuid(src_fs_owner);
+//		}
+
 		if (always_checksum
 		 && (log_format_has(stdout_format, 'C')
 		  || log_format_has(logfile_format, 'C')))
@@ -1028,6 +1417,7 @@
 		flist = send_file_list(f_out, argc, argv);
 		if (verbose > 3)
 			rprintf(FINFO,"file list sent\n");
+		//fprintf(stderr, "DEBUG: send_file_list sent %d items\n", flist->used);
 
 		if (protocol_version >= 23)
 			io_start_multiplex_in();
@@ -1069,6 +1459,7 @@
 	if (inc_recurse && file_total == 1)
 		recv_additional_file_list(f_in);
 
+	//fprintf(stderr, "DEBUG: [%s]client_run received %d items\n", who_am_i(), flist->used);
 	if (flist && flist->used > 0) {
 		local_name = get_local_name(flist, argv[0]);
 
@@ -1156,8 +1547,10 @@
 			am_sender = 0;
 			if (rsync_port)
 				daemon_over_rsh = shell_cmd ? 1 : -1;
+			do_filesystem_compatibility_checks(*argv);
 		} else { /* source is local, check dest arg */
 			am_sender = 1;
+			do_filesystem_compatibility_checks(argv[0]);
 
 			if (argc > 1) {
 				p = argv[--argc];
@@ -1184,7 +1577,11 @@
 					exit_cleanup(RERR_SYNTAX);
 				}
 				shell_machine = NULL;
+				am_sender = 0; // Only while we check the dest path, so dest_fs_owner gets set
+				do_filesystem_compatibility_checks(p);
+				am_sender = 1;
 			} else { /* hostspec was found, so dest is remote */
+				rcvr_is_non_local_server = 1;
 				argv[argc] = path;
 				if (rsync_port)
 					daemon_over_rsh = shell_cmd ? 1 : -1;
@@ -1272,6 +1669,17 @@
 	pid = do_cmd(shell_cmd, shell_machine, shell_user, remote_argv, remote_argc,
 		     &f_in, &f_out);
 
+	// BOMBICH
+	if (verbose > 1) {
+		fprintf(stderr, "DEBUG: [start_client: %s] rcvr_is_non_local_server: %d\n", who_am_i(), rcvr_is_non_local_server);
+	}
+	uid_t my_uid = am_sender ? sender_uid : receiver_uid;
+	if (geteuid() == 0 && my_uid != 0) {
+		fprintf(stderr, "DEBUG: [start_client: %s] Setting effective UID to %d\n", who_am_i(), my_uid);
+		seteuid(my_uid);
+		am_root = geteuid() == 0;
+	}
+
 	/* if we're running an rsync server on the remote host over a
 	 * remote shell command, we need to do the RSYNCD protocol first */
 	if (daemon_over_rsh) {
